PROC macro:
	global opid%,agnfile$(128)
	local text$(255),file$(128),npid%,restart%
	local path$(5),name$(16)
	local ax%,bx%,cx%,dx%,si%,di%
	local ret%,d%,date&
	local p%,b&

REM Test if we're in Agenda
	UseApp:("Active")
	if Pid2App$:(Currpid%:) <> "Agenda"
		ToMacro:
		GiPrint:("Not in Agenda")
		Beep:(10,500)
		return
	endif

REM Save our own PID
	opid%=ActPid%:

REM Save Agenda View
	call($91,opid%,2,0,$2a,addr(b&))
	b&=b&+$1c
	call($91,opid%,1,0,b&,addr(p%))

REM Get default Drive
	name$="sys$shll.*"+chr$(0)
	bx%=addr(name$)+1
	ax%=$0100
	os($88,addr(ax%))
	bx%=ax%
	ax%=$1000
	cx%=addr(path$)+1
	os($87,addr(ax%))
	pokeb addr(path$),call($b9,0,0,0,0,addr(path$)+1)

REM Ask for Notepad file
	ToMacro:
again::
	file$=path$+"note\pad\*.pad"
	DInit
	dText "","Select a Notepad file",$302
	dFile file$,"Name",8
	d%=dialog
	if d%=0 :return :endif
	if upper$(parse$:(file$,5))<>".PAD" and upper$(parse$:(file$,5))<>".EXP"
		d%=Alert:("Not a valid Notepad file","Esc-terminates Enter-Try again","ESC","ENTER","")
		if d%=1 :return :endif
		goto again::
	endif

REM Jump back to Agenda
	UsePid:(opid%)
rem	ToFront:
	if ret% = -33
		ToBack:
		ToFront:
		Key:(enter%)
		Key:(esc%)
	endif
	ret%=testsrv%:
	if ret% = -36
		Alert:("No Data to Bring","","ESC","","")
		return
	endif
	text$=GetText$:

REM Test if Notepad is running with the choosen file
REM If Yes - Shutdown
	if Fil2Pid%:(file$) > 0
		UseFile:(parse$:(file$,6))
rem		ToFront:
		if Info:(1)  or Info:(2) or Info:(3)
			Alert:("Notepad actually locked","Can't continue","ESC","","")
			return
		endif
		kill:
		restart%=1
	endif

REM Search Agenda file for entry
	date&=Agnsrch&:(text$)
	if opid%=-1 :goto end:: :endif

REM Add Notepad entry
	Addentry:(text$,file$,date&)
	if opid%=-1 :goto end:: :endif

end::
REM Restart Notepad if it was running
	if restart%
		npid%=RunAppC:("Notepad",file$)
		if npid% < 0
			Alert:("Can't start Notpad with File",file$,"ENTER","","")
		endif
	endif

REM Jump back to Agenda and stop Macro
	opid%= RunAppC:("Agenda",agnfile$)
	agnkey:(opid%,p%)
	UsePid:(opid%)
	ToFront:
ENDP

PROC parse$:(fil$,req%)
	local b%(6),p$(128),rel$(8),fsys$(8),dev$(2),path$(128),fn$(12),ext$(4)
	p$=parse$(fil$,rel$,b%())
	fsys$=mid$(p$,1,b%(2)-1)
	dev$=mid$(p$,b%(2),b%(3)-b%(2))
	path$=mid$(p$,b%(3),b%(4)-b%(3))
	fn$=mid$(p$,b%(4),b%(5)-b%(4))
	ext$=mid$(p$,b%(5),4)
	if req%=1 :Return fsys$
	elseif req%=2 :return dev$
	elseif req%=3 :return path$
	elseif req%=4 :return fn$
	elseif req%=5 :return ext$
	elseif req%=6 :return fn$+ext$
	elseif req%=7 :return fsys$+dev$+path$+fn$
	elseif req%=8 :return fsys$+dev$+path$+fn$+ext$
	elseif req%=9 :return dev$+path$+fn$+ext$
	elseif req%=10 :return fsys$+dev$
	elseif req%=11 :return dev$+path$
	elseif req%=12 :return dev$+fn$
	elseif req%=13 :return dev$+path$+fn$
	elseif req%=14 :return path$+fn$+ext$
	endif
ENDP

Proc Addentry:(n$,f$,date&)
	local c%,r%,pd&,dc%,p%,d%,un&,file$(128)
	file$=f$
	ToMacro:

	trap open file$,d,n$,dt$,tm$,un$,pdt$,pn$,prio$,exp$,app$,ahead$,stat$,f1$,f2$,f3$,f4$,f5$
	if err
		Alert:("Error Opening Notepad File",err$(err),"ESC","","")
		opid%=-1
		return
	endif
	Dinit
	dtext "","Project Options",$302
	if date&=-1
		pd&=days(day,month,year)
		dc%=2
	else
		pd&=date&
		dc%=1
	endif
	dchoice dc%,"Save with Date:","Yes,No"
	ddate pd&,"Due Date",days(day,month,year-3),days(31,12,2049)
	dchoice c%,"Priority","1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,1,20"
	d%=dialog
	if d%=0 
		use d
		close
		opid%=-1
		return 
	endif
	use d
	last :next
	d.n$=n$
	d.prio$=fix$(c%,0,3)
	d.stat$="1"
	if dc%=1
		d.pdt$=fix$(pd&,0,16)
	endif
	un&=uniq:
	d.un$=fix$(un&,0,16)
	append
	close
	if dc%=1
		trap open FF$:("\note\projdata.dbf")+"\note\projdata.dbf",d,note$,uniq&,date&,b&,head$
		if err
			Alert:("Error Opening Project File",err$(err),"ESC","","")
			opid%=-1
			return
		endif
		d.note$=n$
		d.uniq&=un&
		d.date&=pd&
		d.head$=left$(upper$(parse$:(file$,2)),1)
		if upper$(parse$:(file$,5))=".PAD"
			d.head$=d.head$+"M"
		else
			d.head$=d.head$+"P"
		endif
		d.head$=d.head$+upper$(parse$:(file$,4))
		append
		close
	endif
ENDP

Proc FF$:(p$)
local dr$(3,2),l%
dr$(1)="M:" :dr$(2)="A:" :dr$(3)="B:"
onerr fe
l%=1
top::
do
 if exist(dr$(l%)+p$)
  return dr$(l%)
 endif
 l%=l%+1
until l%>3
return ""
fe::
l%=l%+1
if l%<4
 goto top
endif
Endp

Proc uniq:
local ax%,bx%,cx%,dx%,si%,di%,seed&
ax%=$0200
OS($89,addr(ax%)) Rem TimGetSystemTime
pokew addr(seed&),bx%
pokew addr(seed&)+2,ax%
randomize seed&
return int(rnd*1000000000)
Endp

Proc Testsrv%:
	local wsrv$(15),in%(6),fmt&,pid%,pfmt%
	
	wsrv$="SYS$WSRV.*"+chr$(0)
	in%(1)=$0100
	in%(2)=uadd(addr(wsrv$),1)
	if os($88,addr(in%(1))) and 1
		return (in%(1) and $ff) - $100
	else
		pid%=in%(1)
	endif
	pfmt%=addr(fmt&)
	if call($0683,pid%,4,0,addr(pfmt%),0)<=0
		return -33
	endif
	if (fmt& and $16) = 0
		return -36
	endif
ENDP

Proc Agnsrch&:(text$)
	local mode%,buffer$(255),bufaddr%,err%,acb%,offset&,ret%,len%
	local d&,d1&,lbyte%,typlen%(4),found%,type%
	local data%(7),attr%
rem	local f1%,f2%,f3%,f4%,f5%,f6
	local yr%,mo%,dy%,hr%,mn%,sc%,yd%

REM Save Filename
	call($dc,opid%,128,0,$3e,uadd(addr(agnfile$),1))
	pokeb addr(agnfile$),call($b9,0,0,0,0,addr(agnfile$)+1)

REM Close down Agenda Task to search for entry
	UsePid:(opid%)
rem	ToFront:
rem	Exit:
	Kill:
	mode%=$0600
	bufaddr%=addr(buffer$)+1
	err%=ioopen(acb%,agnfile$,mode%)
	if err%
		Alert:("Error Opening File "+agnfile$,err$(err%),"ESC","","")
		opid%=-1
		return
	endif
	ToMacro:
	typlen%(1)=8
	typlen%(2)=6
	typlen%(3)=9
	typlen%(4)=14
	mode%=1
	offset&=32
	Busy "Searching Entry ..."
	do
		ret%=ioseek(acb%,mode%,offset&)
		if ret% < 0
			Alert:("E r r o r",err$(ret%),"ESC","","")
			ioclose(acb%)
			opid%=-1
			return
		endif
		ret%=ioread(acb%,addr(len%),2)
		if ret%<0
			if ret%=-36
				ioclose(acb%)
				opid%=-1
				return
			endif
		elseif ret%<0
			Alert:("E r r o r",err$(ret%),"ESC","","")
			ioclose(acb%)
			opid%=-1
			return
		endif
		offset&=len% and $0000ffff
		type%=(offset& and $f000)/256/16
		offset&=(offset& and $0fff)
		if type% > 0 and type% < 5
			ret%=ioread(acb%,addr(data%()),typlen%(type%))
			offset&=offset&-typlen%(type%)
			ret%=ioread(acb%,addr(lbyte%),2)
			ret%=ioread(acb%,bufaddr%,lbyte%/256)
			pokeb bufaddr%-1,ret%
			offset&=offset&-2-ret%
			if buffer$=text$
				REM Read Attribute
				attr%=peekb(addr(data%(3)))
				REM Read Date
				d1&=data%(1)
				if type%=4 :d1&=data%(4) :endif
				if d1& >= 0
					d&=d1&*86400
					secstodate d&,yr%,mo%,dy%,hr%,mn%,sc%,yr%
					d&=days(dy%,mo%,yr%)
					if type%=3       REM If Anniversary => Set Year = actual Year
						d&=days(dy%,mo%,year)
					elseif type%<>3
						if attr% and 1
							rem Nothing - No Repeat Entry
						else
							d&=days(day,month,year)   REM If Repeat Entry => Set Date = Today
						endif
					endif
				else
					d&=d1&
				endif
				found%=1
				continue
			endif
		endif
		mode%=3
	until found%=1
	ioclose(acb%)
	Busy off
	opid%=0
	return d&
ENDP

Proc agnkey:(q%,d%)
	call($198d,0,q%) : gupdate
	if d%=1
		send:($277,10,q%)
	elseif d%=2
		send:($279,10,q%)
	elseif d%=3
		send:($274,10,q%)
	elseif d%=4
		send:($261,10,q%)
	elseif d%=5
		send:($26c,10,q%)
	endif
rem	call($198d,100,q%) : gupdate
	ENDP

Proc send:(a%,b%,c%)
	local ax%,bx%,cx%,dx%,si%,di%
	local k%,m%,ppid%,f%
	k%=a%
	m%=b%
	ppid%=c%
sloop::
	ax%=$400
	bx%=ppid%
	cx%=$31
	dx%=0
	si%=addr(k%)
	di%=0
	f%=os($83,addr(ax%))
	if (f% and 1)=1
		goto sloop::
	endif
ENDP

